#ifndef BZIO_H
#define BZIO_H

/* Under Windows bzip2 and Allegro kill eachother with preprocessor
   directives, so I've decided it's best no not let have them
   included in the same file; hence this file of wrapper functions. 
   
   Actually it's just as well; it made using bzip2 a lot easier.
   
   */

#include <stdio.h>

typedef struct
 {
  FILE * file;
 } bzf;

bzf *bz_OpenWrite(const char *filename);
bzf *bz_OpenRead(const char *filename);
int  bz_Read(bzf *file, void *data, unsigned int len);
int  bz_Write(bzf *file, const void *data, unsigned int len);
int  bz_Flush(bzf *file);
void bz_CloseWrite(bzf *file);
void bz_CloseRead(bzf *file);

#endif

