#ifndef MEM_H
#define MEM_H

#include <stdlib.h>

#if !defined(NDEBUG) && defined(MEM_CHECK)

extern void * mallocTrace(unsigned int, const char *file, const char *function, unsigned int line);
extern void freeTrace(void *, const char *file, const char *function, unsigned int line);
extern void * reallocTrace(void *, unsigned int, const char *file, const char *function, unsigned int line);
extern int verifyTrace(void *, const char *file, const char *function, unsigned int line);

#ifdef malloc
#undef malloc
#endif

#define malloc(A) mallocTrace(A, __FILE__, __PRETTY_FUNCTION__, __LINE__)

#ifdef free
#undef free
#endif

#define free(A) freeTrace(A, __FILE__, __PRETTY_FUNCTION__, __LINE__)

#ifdef realloc
#undef realloc
#endif
#define realloc(A, B) reallocTrace(A, B, __FILE__, __PRETTY_FUNCTION__, __LINE__)

#define verifyPointer(A) verifyTrace(A, __FILE__, __PRETTY_FUNCTION__, __LINE__)

#else
#define verifyPointer(A) (1)
#endif

#endif
