#ifndef VIDEO_DUMP_H
#define VIDEO_DUMP_H

#include <allegro.h>
#include <stdio.h>

typedef struct
 {
  unsigned int base;
  float *start, *end;
 } ScaleInfo;

typedef struct
 {
  FILE *out;
  unsigned int w, h;
  unsigned char *frame_buffer;
  ScaleInfo *x, *y;
  BITMAP *in;
 } VideoDump;

extern VideoDump *createVideoDump(FILE *out, BITMAP *in, unsigned int width, unsigned int height);
extern int performDump(VideoDump *dump);
extern int duplicatePreviousFrame(VideoDump *dump);
extern void releaseVideoDump(VideoDump *dump);

#endif
